// Modelise a memory catch. 

#include <stdio.h>
#include "memory_catch.h"

#define SIZE_MEMORY_CATCH 65000

char **string_array[SIZE_MEMORY_CATCH];

void init_memory_catch() {
  // Initialize dictionnary.
  int i = 0;
  for(i=0 ; i < SIZE_MEMORY_CATCH ; i++)
    string_array[i] = NULL;
}

void add_new_buffer(long locate_buffer) {
  // add a new array.
  char **buffer;
  int i;
  buffer = (char **)(malloc(SIZE_MEMORY_CATCH*sizeof(char *)));
  if (!buffer) {
    fprintf(stderr, "Not enough memory job of memory_catch.\n");
    exit(1);
  }
  for(i=0 ; i < SIZE_MEMORY_CATCH ; i++)
    *(buffer + i) = NULL;
  string_array[locate_buffer % SIZE_MEMORY_CATCH] = buffer;
}

void put_string(long locate_buffer, int locate, char *string) {
  // put a string in memory_catch.
  char **buffer; 
  // printf("je range dans le buffer %d  l'emplacement %d.\n", locate_buffer, locate);
  buffer = string_array[locate_buffer % SIZE_MEMORY_CATCH];
  *(buffer + locate) = string;

}

char *get_string(long locate_buffer, int locate) {
  // send the pt of string which locate at locate. If the locate doesn't exist then send NULL.
  char **buffer;
  buffer = string_array[locate_buffer % SIZE_MEMORY_CATCH];
  if (buffer == NULL) 
    return(NULL);
  else {
    return(*(buffer + locate));
  }
}

void delete_string(long locate_buffer) {
  // delete the string locate in locate_buffer.
  char **buffer, *tiny_buffer;
  int locate = 0;
  buffer = string_array[locate_buffer % SIZE_MEMORY_CATCH];
  if (buffer != NULL) {
    do {
      tiny_buffer = get_string(locate_buffer, locate++);
      free(tiny_buffer);
    } while(tiny_buffer != NULL);
    string_array[locate_buffer % SIZE_MEMORY_CATCH] = NULL;
    free(buffer);
  }
}

