#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <pthread.h>
#include <signal.h>

#define MYPORT_RECEIVE 3485 // the port users will be connecting to. It can receive the controls.
#define MYPORT_SEND 3486  // This port can send the results.

#define BACKLOG 100     // how many pending connections queue will hold

#define SIZE_CONTROL 100 // size (number of character) of the control. 

int tube[2], new_fd;

void sigchld_handler(int s)
{
  while(wait(NULL) > 0);
}

void *send_results() {
  int a_socket, yes_thread, sin_size_thread, new_fd_thread;
  struct sockaddr_in my_addr_thread, their_addr_thread;
  struct sigaction sa_thread;
  // printf("je suis dans le thread \n");
  if ((a_socket = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("socket");
    exit(1);
  }
  
  if (setsockopt(a_socket,SOL_SOCKET,SO_REUSEADDR,&yes_thread,sizeof(int)) == -1) {
    perror("setsockopt");
    exit(1);
  }
  
  my_addr_thread.sin_family = AF_INET;         // host byte order
  my_addr_thread.sin_port = htons(MYPORT_SEND);     // short, network byte order
  my_addr_thread.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
  memset(&(my_addr_thread.sin_zero), '\0', 8); // zero the rest of the struct
  
  if (bind(a_socket, (struct sockaddr *)&my_addr_thread, sizeof(struct sockaddr)) == -1) {
    perror("bind");
    exit(1);
  }
  if (listen(a_socket, BACKLOG) == -1) {
    perror("listen");
    exit(1);
  }
  
  sa_thread.sa_handler = sigchld_handler; // reap all dead processes
  sigemptyset(&sa_thread.sa_mask);
  sa_thread.sa_flags = SA_RESTART;
  if (sigaction(SIGCHLD, &sa_thread, NULL) == -1) {
    perror("sigaction");
    exit(1);
  }
  sin_size_thread = sizeof(struct sockaddr_in);
  if ((new_fd_thread = accept(a_socket, (struct sockaddr *)&their_addr_thread,
		       &sin_size_thread)) == -1) {
    perror("accept");
  }
  int n;
  char ch[1024];
  /* process pere */ 
  // close (tube[1]); 
  // sleep(10);
  // printf("lecture.\n");
  close(tube[1]);
  while((n = read(tube[0], ch, 1023)) > 0) {
    // fscanf(in,"%s", ch); // lecture du tube 
    // fprintf(stderr, "tube[0]=%d", tube[0]);
    // fflush(stderr);
    ch[n] = 0;
    // fprintf(stderr, "n = %d\n", n);
    // fflush(stderr);
    send(new_fd_thread, ch, n, 0);
    // printf("%s", ch);
    // printf("fin = %d\n", fin); 
    recv(new_fd_thread, ch, 7, 0);
    // fflush(0);
  }
  // printf("fin\n");
  system("sleep 1");
  send(new_fd_thread, "finish", 6, 0);
  recv(new_fd_thread, ch, 7, 0);
  // printf("reception\n");
  close(new_fd_thread);
  close(a_socket);
  // fin = 1;
  // fclose(in); 
}

void fonct() {}

int main()
{
  int sockfd;  // listen on sock_fd, new connection on new_fd
  struct sockaddr_in my_addr;    // my address information
  struct sockaddr_in their_addr; // connector's address information
  int sin_size, numcar, nbr_controls = 0;
  struct sigaction sa;
  int yes = 1, name_pipe = 0, fd;
  char buffer[100], *control, *array_controls[6];
  pthread_t a_thread;
  pthread_attr_t thread_attr;

  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("socket");
    exit(1);
  }
  
  if (setsockopt(sockfd,SOL_SOCKET,SO_REUSEADDR,&yes,sizeof(int)) == -1) {
    perror("setsockopt");
    exit(1);
  }
  
  my_addr.sin_family = AF_INET;         // host byte order
  my_addr.sin_port = htons(MYPORT_RECEIVE);     // short, network byte order
  my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
  memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct
  
  if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
    perror("bind");
    exit(1);
  }
  if (listen(sockfd, BACKLOG) == -1) {
    perror("listen");
    exit(1);
  }
  
  sa.sa_handler = sigchld_handler; // reap all dead processes
  sigemptyset(&sa.sa_mask);
  sa.sa_flags = SA_RESTART;
  if (sigaction(SIGCHLD, &sa, NULL) == -1) {
    perror("sigaction");
    exit(1);
  }
  
  while(1) {  // main accept() loop
    sin_size = sizeof(struct sockaddr_in);
    if ((new_fd = accept(sockfd, (struct sockaddr *)&their_addr,
			 &sin_size)) == -1) {
      perror("accept");
      continue;
    }
    if (!fork()) { // this is the child process;
      // Build a thread to send the results.
      /* if (pthread_attr_init (&thread_attr) != 0) {
	fprintf (stderr, "pthread_attr_init error");
	exit (1);
      }
      
      if (pthread_attr_setdetachstate (&thread_attr, PTHREAD_CREATE_DETACHED) != 0) {
	fprintf (stderr, "pthread_attr_setdetachstate error");
	exit (1);
      }
      pthread_create(&a_thread, &thread_attr, send_results, NULL); */

      // Wait the thread.
      // pthread_join(a_thread, NULL);
      close(sockfd); // child doesn't need the listener
      // initialisation the variables.
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[0] = control;
      strcpy(control, "mpirun");
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[1] = control;
      strcpy(control, "-np");
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[2] = control;
      strcpy(control, "6");
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[3] = control;
      strcpy(control, "dispatcher");
      // printf("chemin = %s", control);
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[4] = control;
      sprintf(control, "%d", name_pipe++);
      array_controls[5] = NULL;
      // Case : the execvp control need the last element of array is null
      int i;
      // fprintf(stderr, "ouverture d'un pipe\n");
      // fflush(stderr);
      if (pipe(tube) == -1) { 
	perror("Ouverture pipe impossible"); 
	exit(1); 
      } 
      i=fork(); 
      
      if (i==0) { 
	/* process fils */ 
	printf("on lance mpirun.\n");
	close(1); /* fermeture sortie std */ 
	dup2(tube[1], 1);  /* redirection sortie std sur descripteur en ecriture du tube */ 
	close(tube[0]);  /* fermeture du descripteur inutilise */  
	execvp("mpirun", array_controls); 
	free(control);
	// execlp("ls", "ls", NULL);
	perror("Lancement de mpirun"); 
      } 
      else {
	// build a name pipe.
	
	// printf("debut open.\n");
	// printf("nom du pipe : %s\n", control);
	if (!fork()) {
	  close(new_fd);
	  send_results();
	  exit(0);
	}
	sleep(2);
	if ((fd=open(control, O_WRONLY))==-1) { 
	  perror("server : Open the name pipe"); 
	  exit(1); 
	} 
	// Reception the controls from a client.
	// printf("fin open.\n");
	// fflush(stdout);
	while (strcmp(buffer, "finish")) {
	  // printf("control.\n");
	  if ((numcar = recv(new_fd, buffer, 99, 0)) == -1)
	    perror("recv");
	  buffer[numcar]='\0';
	  // printf("avant ecriture\n");
	  // sleep(1);
	  // printf("%s\n", buffer);
	  if (write(fd, buffer, 100) != 100) { 
	    perror("server : write with the name pipe"); 
	    exit(1);
	  } 
	  // nbr_controls++;
	  // printf("nbr_controls = %d", nbr_controls % 1000);
	  /* if (nbr_controls % 1000 == 0) {
	    printf("nbr_controls\n");
	    signal(SIGHUP, fonct);
	    nbr_controls = 0;
	    } */
	  // printf("%s.\n", buffer);
	  send(new_fd, "encore", 7, 0);
	}
	close(fd);
	}
      // Communication is terminated.
      close(new_fd);
      printf("c'est fini\n");
      exit(0);
    }
  }   
  /* while(!fin) {
    fprintf(stderr, "attend\n");
    fflush(stderr);
    } */
  // fflush(stdout);
  close(new_fd);  // parent doesn't need this
  return 0;
} 

